Subject: Re: internet draft on suggested mod to the Nagle algorithm

From: David Borman <[email-masked]>
Date: Wed, 3 Mar 1999 17:48:10 -0600 (CST)

> Subject: Re: internet draft on suggested mod to the Nagle algorithm 
> Date: Wed, 3 Mar 1999 13:53:55 PST
> From: Bill Fenner <[email-masked]>
>
> I think a lot of the question of what applying Nagle on a per-send
> basis means includes what happens when data is delayed due to cwnd
> or the receive window.  My imagination says that you keep another
> variable in the TCB that's the highest sequence number that has
> passed Nagle (in order to not delay the last packet of a large
> write), but I haven't particularly thought through exactly how this
> variable is updated or used except in the obvious case.  In
> particular, I don't know how it should be updated when you perform
> a send() and there is still data outstanding.

I've had similar thoughts.

The Nagle sequence number advances when:
      o there is a large send() or TCP_NODELAY is set,
	to the end of the data.
      o any data is actually sent, to the end of that data.
It never retreats.

Decisions on whether or not to send based on TCP_NODELAY are
changed to decide whether or not to send based upon if the
send next sequence number is in front of the Nagle sequence number.

			-David Borman, [email-masked]

---

From: Rick Jones <[email-masked]>
Date: Wed, 03 Mar 1999 17:16:31 -0800

OK, time for another one of my naieve, ignorance exposing questions...

Why is there any need to track a sequence number here? I send data, but
cwnd prevents me from sending it all. The remote will send me an ACK
within one RTT, and say I only have a small quantity of data left to
send because the app has not sent more or has only trickled a little
more out. The app has had an RTT to give TCP more data, and that is
probably eons in local system timescales, so if there is no more data by
the time the ACK advancing cwnd comes back, there probably isn't likely
to be any additional data for any apreciable time anyway.

So, why not just send the remainder all the time? 

rick jones
-- 
these opinions are mine, all mine; HP might not want them anyway... :)
feel free to email, or post, but please do not do both...
my email address is raj in the cup.hp.com domain...